package com.sun.appserver.hatests.sfsb.sfbtc25;

import javax.ejb.EJB;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.transaction.UserTransaction;
import java.io.IOException;
import java.io.PrintWriter;

public class StatefulCmtServlet extends HttpServlet {
    HttpSession session;
    PrintWriter out;
    @EJB
    StatefulCmtBean statefulCmtRemote;

    public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        session = request.getSession(true);
        out = response.getWriter();
        out.println("Executed From Instance: <b>" + System.getProperty("com.sun.aas.instanceName") + "</b><br>");


        String method = request.getParameter("method");
        if (method.equals("beforeFailover")) {
            callSFSB();
        }
        if (method.equals("afterFailover")) {
            callSFSBFailover();
        }

    }

    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        doPost(request, response);

    }

    public void callSFSB() {
        int result = 0;
        try {
            InitialContext initContext = new InitialContext();

            UserTransaction utx = (UserTransaction) initContext.lookup("java:comp/UserTransaction");

            utx.begin();

            result = statefulCmtRemote.getItems();
            out.println("result ***" + result);
            statefulCmtRemote.setItems();
            result = statefulCmtRemote.getItems();
            out.println("result=" + result);

            utx.commit();

            session.setAttribute("statefulCmtRemote", statefulCmtRemote);
            out.println("Injection of StatefulCmtBean succeeded");
        } catch (Exception e) {
            out.println("Exception in StatefulCmtBean" + e.getMessage());
            e.printStackTrace(out);
        }

    }


    public void callSFSBFailover() {
        try {


            int result = 0;
            statefulCmtRemote = (StatefulCmtBean) session.getAttribute("statefulCmtRemote");
            if (statefulCmtRemote != null) {
                out.println("obtained remote ref from session");
            }

            InitialContext initContext = new InitialContext();
            UserTransaction utx = (UserTransaction) initContext.lookup("java:comp/UserTransaction");

            utx.begin();

            result = statefulCmtRemote.getItems();
            out.println("result ***" + result);
            statefulCmtRemote.setItems();
            result = statefulCmtRemote.getItems();
            out.println("result=" + result);

            utx.commit();

            session.setAttribute("statefulCmtRemote", statefulCmtRemote);
        } catch (Exception e) {
            out.println("Exception in StatefulCmtBean" + e.getMessage());
            e.printStackTrace(out);
        }

    }

}
